diff -ruN qmail-1.03-orig/base64.c qmail-1.03-ldap-20060201-orig/base64.c
--- qmail-1.03-orig/base64.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/base64.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,530 @@
+/* base64.c for QLDAP modified to use only djb's qmail stuff */
+
+/*        */
+/* BASE64 */
+/*        */
+
+/*
+ * Copyright (c) 1996 by Internet Software Consortium.
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
+ * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
+ * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
+ * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
+ * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
+ * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
+ * SOFTWARE.
+ */
+
+/*
+ * Portions Copyright (c) 1995 by International Business Machines, Inc.
+ *
+ * International Business Machines, Inc. (hereinafter called IBM) grants
+ * permission under its copyrights to use, copy, modify, and distribute this
+ * Software with or without fee, provided that the above copyright notice and
+ * all paragraphs of this notice appear in all copies, and that the name of IBM
+ * not be used in connection with the marketing of any product incorporating
+ * the Software or modifications thereof, without specific, written prior
+ * permission.
+ *
+ * To the extent it has a right to do so, IBM grants an immunity from suit
+ * under its patents, if any, for the use, sale or manufacture of products to
+ * the extent that such products are used for performing Domain Name System
+ * dynamic updates in TCP/IP networks by means of the Software.  No immunity is
+ * granted for any product per se or for any other function of any product.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", AND IBM DISCLAIMS ALL WARRANTIES,
+ * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+ * PARTICULAR PURPOSE.  IN NO EVENT SHALL IBM BE LIABLE FOR ANY SPECIAL,
+ * DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER ARISING
+ * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE, EVEN
+ * IF IBM IS APPRISED OF THE POSSIBILITY OF SUCH DAMAGES.
+ */
+
+#include <sys/types.h>
+#include "str.h"
+#include "stralloc.h"
+#include "strerr.h"
+
+#define Assert(Cond) if (!(Cond)) strerr_die1x(111, "Abort: assert condition false in base64.")
+
+static const char Base64[] =
+	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
+static const char Pad64 = '=';
+
+/* (From RFC1521 and draft-ietf-dnssec-secext-03.txt)
+   The following encoding technique is taken from RFC 1521 by Borenstein
+   and Freed.  It is reproduced here in a slightly edited form for
+   convenience.
+
+   A 65-character subset of US-ASCII is used, enabling 6 bits to be
+   represented per printable character. (The extra 65th character, "=",
+   is used to signify a special processing function.)
+
+   The encoding process represents 24-bit groups of input bits as output
+   strings of 4 encoded characters. Proceeding from left to right, a
+   24-bit input group is formed by concatenating 3 8-bit input groups.
+   These 24 bits are then treated as 4 concatenated 6-bit groups, each
+   of which is translated into a single digit in the base64 alphabet.
+
+   Each 6-bit group is used as an index into an array of 64 printable
+   characters. The character referenced by the index is placed in the
+   output string.
+
+                         Table 1: The Base64 Alphabet
+
+      Value Encoding  Value Encoding  Value Encoding  Value Encoding
+          0 A            17 R            34 i            51 z
+          1 B            18 S            35 j            52 0
+          2 C            19 T            36 k            53 1
+          3 D            20 U            37 l            54 2
+          4 E            21 V            38 m            55 3
+          5 F            22 W            39 n            56 4
+          6 G            23 X            40 o            57 5
+          7 H            24 Y            41 p            58 6
+          8 I            25 Z            42 q            59 7
+          9 J            26 a            43 r            60 8
+         10 K            27 b            44 s            61 9
+         11 L            28 c            45 t            62 +
+         12 M            29 d            46 u            63 /
+         13 N            30 e            47 v
+         14 O            31 f            48 w         (pad) =
+         15 P            32 g            49 x
+         16 Q            33 h            50 y
+
+   Special processing is performed if fewer than 24 bits are available
+   at the end of the data being encoded.  A full encoding quantum is
+   always completed at the end of a quantity.  When fewer than 24 input
+   bits are available in an input group, zero bits are added (on the
+   right) to form an integral number of 6-bit groups.  Padding at the
+   end of the data is performed using the '=' character.
+
+   Since all base64 input is an integral number of octets, only the
+         -------------------------------------------------                       
+   following cases can arise:
+   
+       (1) the final quantum of encoding input is an integral
+           multiple of 24 bits; here, the final unit of encoded
+	   output will be an integral multiple of 4 characters
+	   with no "=" padding,
+       (2) the final quantum of encoding input is exactly 8 bits;
+           here, the final unit of encoded output will be two
+	   characters followed by two "=" padding characters, or
+       (3) the final quantum of encoding input is exactly 16 bits;
+           here, the final unit of encoded output will be three
+	   characters followed by one "=" padding character.
+   */
+
+int
+b64_ntop(unsigned char const *src, size_t srclength, 
+    char *target, size_t targsize)
+{
+	size_t datalength = 0;
+	unsigned char input[3];
+	unsigned char output[4];
+	size_t i;
+
+	while (2 < srclength) {
+		input[0] = *src++;
+		input[1] = *src++;
+		input[2] = *src++;
+		srclength -= 3;
+
+		output[0] = input[0] >> 2;
+		output[1] = ((input[0] & 0x03) << 4) + (input[1] >> 4);
+		output[2] = ((input[1] & 0x0f) << 2) + (input[2] >> 6);
+		output[3] = input[2] & 0x3f;
+		Assert(output[0] < 64);
+		Assert(output[1] < 64);
+		Assert(output[2] < 64);
+		Assert(output[3] < 64);
+
+		if (datalength + 4 > targsize)
+			return (-1);
+		target[datalength++] = Base64[output[0]];
+		target[datalength++] = Base64[output[1]];
+		target[datalength++] = Base64[output[2]];
+		target[datalength++] = Base64[output[3]];
+	}
+
+	/* Now we worry about padding. */
+	if (0 != srclength) {
+		/* Get what's left. */
+		input[0] = input[1] = input[2] = '\0';
+		for (i = 0; i < srclength; i++)
+			input[i] = *src++;
+
+		output[0] = input[0] >> 2;
+		output[1] = ((input[0] & 0x03) << 4) + (input[1] >> 4);
+		output[2] = ((input[1] & 0x0f) << 2) + (input[2] >> 6);
+		Assert(output[0] < 64);
+		Assert(output[1] < 64);
+		Assert(output[2] < 64);
+
+		if (datalength + 4 > targsize)
+			return (-1);
+		target[datalength++] = Base64[output[0]];
+		target[datalength++] = Base64[output[1]];
+		if (srclength == 1)
+			target[datalength++] = Pad64;
+		else
+			target[datalength++] = Base64[output[2]];
+		target[datalength++] = Pad64;
+	}
+	if (datalength >= targsize)
+		return (-1);
+	target[datalength] = '\0';	/* Returned value doesn't count \0. */
+	return (datalength);
+}
+
+/* skips all whitespace anywhere.
+   converts characters, four at a time, starting at (or after)
+   src from base - 64 numbers into three 8 bit bytes in the target area.
+   it returns the number of data bytes stored at the target, or -1 on error.
+ */
+
+#define ISSPACE(x) ((x) == ' ' || (x) == '\t' || (x) == '\n' || (x) == '\r')
+/* XXX
+   this is not the complete subset of ctypes.h isspace but for qmail-ldap
+   only space, tab, newline and carriage-return are useful (formfeed and 
+   vertical tabs are normaly not used in network communications.
+                                            Claudio Jeker
+ */
+
+int
+b64_pton(char const *src, unsigned char *target, size_t targsize)
+{
+	size_t tarindex;
+	int state, ch;
+	unsigned int pos;
+
+	state = 0;
+	tarindex = 0;
+
+	while ((ch = *src++) != '\0') {
+		if (ISSPACE(ch))	/* Skip whitespace anywhere. */
+			continue;
+
+		if (ch == Pad64)
+			break;
+
+		pos = str_chr(Base64, ch);
+		if (pos > 63) 		/* A non-base64 character. */
+			return (-1);
+
+		switch (state) {
+		case 0:
+			if (target) {
+				if (tarindex >= targsize)
+					return (-1);
+				target[tarindex] = pos << 2;
+			}
+			state = 1;
+			break;
+		case 1:
+			if (target) {
+				if (tarindex + 1 >= targsize)
+					return (-1);
+				target[tarindex]   |=  pos >> 4;
+				target[tarindex+1]  = (pos & 0x0f) << 4 ;
+			}
+			tarindex++;
+			state = 2;
+			break;
+		case 2:
+			if (target) {
+				if (tarindex + 1 >= targsize)
+					return (-1);
+				target[tarindex]   |=  pos >> 2;
+				target[tarindex+1]  = (pos & 0x03) << 6;
+			}
+			tarindex++;
+			state = 3;
+			break;
+		case 3:
+			if (target) {
+				if (tarindex >= targsize)
+					return (-1);
+				target[tarindex] |= pos;
+			}
+			tarindex++;
+			state = 0;
+			break;
+		default:
+			strerr_die1x(111, "Abort: bad state in base64 decode.");
+		}
+	}
+
+	/*
+	 * We are done decoding Base-64 chars.  Let's see if we ended
+	 * on a byte boundary, and/or with erroneous trailing characters.
+	 */
+
+	if (ch == Pad64) {		/* We got a pad char. */
+		ch = *src++;		/* Skip it, get next. */
+		switch (state) {
+		case 0:		/* Invalid = in first position */
+		case 1:		/* Invalid = in second position */
+			return (-1);
+
+		case 2:		/* Valid, means one byte of info */
+			/* Skip any number of spaces. */
+			for (; ch != '\0'; ch = *src++)
+				if (!ISSPACE(ch))
+					break;
+			/* Make sure there is another trailing = sign. */
+			if (ch != Pad64)
+				return (-1);
+			ch = *src++;		/* Skip the = */
+			/* Fall through to "single trailing =" case. */
+			/* FALLTHROUGH */
+
+		case 3:		/* Valid, means two bytes of info */
+			/*
+			 * We know this char is an =.  Is there anything but
+			 * whitespace after it?
+			 */
+			for (; ch != '\0'; ch = *src++)
+				if (!ISSPACE(ch))
+					return (-1);
+
+			/*
+			 * Now make sure for cases 2 and 3 that the "extra"
+			 * bits that slopped past the last full byte were
+			 * zeros.  If we don't check them, they become a
+			 * subliminal channel.
+			 */
+			if (target && target[tarindex] != 0)
+				return (-1);
+		}
+	} else {
+		/*
+		 * We ended by seeing the end of the string.  Make sure we
+		 * have no partial bytes lying around.
+		 */
+		if (state != 0)
+			return (-1);
+	}
+
+	return (tarindex);
+}
+
+int
+b64_ntops(unsigned char const *src, size_t srclength, stralloc *dest)
+{
+	unsigned char input[3];
+	unsigned char output[4];
+	size_t i;
+
+	if (!stralloc_copys(dest, "")) return -1;
+	while (2 < srclength) {
+		input[0] = *src++;
+		input[1] = *src++;
+		input[2] = *src++;
+		srclength -= 3;
+
+		output[0] = input[0] >> 2;
+		output[1] = ((input[0] & 0x03) << 4) + (input[1] >> 4);
+		output[2] = ((input[1] & 0x0f) << 2) + (input[2] >> 6);
+		output[3] = input[2] & 0x3f;
+		Assert(output[0] < 64);
+		Assert(output[1] < 64);
+		Assert(output[2] < 64);
+		Assert(output[3] < 64);
+		output[0] = Base64[output[0]];
+		output[1] = Base64[output[1]];
+		output[2] = Base64[output[2]];
+		output[3] = Base64[output[3]];
+		
+		if (!stralloc_catb(dest, output, 4)) return -1;
+	}
+
+	/* Now we worry about padding. */
+	if (0 != srclength) {
+		/* Get what's left. */
+		input[0] = input[1] = input[2] = '\0';
+		for (i = 0; i < srclength; i++)
+			input[i] = *src++;
+
+		output[0] = input[0] >> 2;
+		output[1] = ((input[0] & 0x03) << 4) + (input[1] >> 4);
+		output[2] = ((input[1] & 0x0f) << 2) + (input[2] >> 6);
+		Assert(output[0] < 64);
+		Assert(output[1] < 64);
+		Assert(output[2] < 64);
+
+		if (!stralloc_append(dest, &Base64[output[0]])) return -1;
+		if (!stralloc_append(dest, &Base64[output[1]])) return -1;
+		if (srclength == 1) {
+			if (!stralloc_append(dest, &Pad64)) return -1;
+		} else {
+			if (!stralloc_append(dest, &Base64[output[2]]))
+				return -1;
+		}
+		if (!stralloc_catb(dest, &Pad64, 1)) return -1;
+	}
+	return 0;
+}
+
+int
+b64_ptons(char const *src, stralloc *dest)
+{
+	unsigned char out[3];
+	int state, ch;
+	unsigned int pos;
+
+	state = 0;
+
+	if (!stralloc_copys(dest, "")) return -1;
+	while ((ch = *src++) != '\0') {
+		if (ISSPACE(ch))	/* Skip whitespace anywhere. */
+			continue;
+
+		if (ch == Pad64)
+			break;
+
+		pos = str_chr(Base64, ch);
+		if (pos > 63) 		/* A non-base64 character. */
+			return (-1);
+
+		switch (state) {
+		case 0:
+			out[0] = pos << 2;
+			state = 1;
+			break;
+		case 1:
+			out[0] |=  pos >> 4;
+			out[1] = (pos & 0x0f) << 4;
+			state = 2;
+			break;
+		case 2:
+			out[1] |=  pos >> 2;
+			out[2] = (pos & 0x03) << 6;
+			state = 3;
+			break;
+		case 3:
+			out[2] |= pos;
+			if (!stralloc_catb(dest, out, 3)) return -1;
+			state = 0;
+			break;
+		default:
+			strerr_die1x(111, "Abort: bad state in base64 decode.");
+		}
+	}
+
+	/*
+	 * We are done decoding Base-64 chars.  Let's see if we ended
+	 * on a byte boundary, and/or with erroneous trailing characters.
+	 */
+
+	if (ch == Pad64) {		/* We got a pad char. */
+		ch = *src++;		/* Skip it, get next. */
+		switch (state) {
+		case 0:		/* Invalid = in first position */
+		case 1:		/* Invalid = in second position */
+			return (-1);
+
+		case 2:		/* Valid, means one byte of info */
+			/* Skip any number of spaces. */
+			for (; ch != '\0'; ch = *src++)
+				if (!ISSPACE(ch))
+					break;
+			/* Make sure there is another trailing = sign. */
+			if (ch != Pad64)
+				return (-1);
+			ch = *src++;		/* Skip the = */
+			/* Fall through to "single trailing =" case. */
+			/* FALLTHROUGH */
+
+		case 3:		/* Valid, means two bytes of info */
+			/*
+			 * We know this char is an =.  Is there anything but
+			 * whitespace after it?
+			 */
+			for (; ch != '\0'; ch = *src++)
+				if (!ISSPACE(ch))
+					return (-1);
+
+			/*
+			 * Now we need to write the one or two bytes of
+			 * info to the stralloc.
+			 */
+			if (state == 2) { /* one byte */
+				if (!stralloc_catb(dest, out, 1)) return -1;
+			} else { /* two bytes */
+				if (!stralloc_catb(dest, out, 2)) return -1;
+			}
+		}
+	} else {
+		/*
+		 * We ended by seeing the end of the string.  Make sure we
+		 * have no partial bytes lying around.
+		 */
+		if (state != 0)
+			return (-1);
+	}
+
+	return 0;
+}
+
+/* function for decoding and encoding hex strings */
+static const char Hex[] = "0123456789abcdef";
+/* static const char HexBig[] = "0123456789ABCDEF"; */
+
+int
+hex_ntops(unsigned char const *src, size_t srclength, stralloc *dest)
+{
+	size_t	i;
+	
+	if (!stralloc_copys(dest, "")) return -1;
+	for (i=0; i<srclength; i++) {
+		if (!stralloc_append(dest, &Hex[src[i] >> 4])) return -1;
+		if (!stralloc_append(dest, &Hex[src[i] & 0x0f])) return -1;
+	}
+	return 0;
+}
+
+int
+hex_ptons(char const *src, stralloc *dest)
+{
+	int		state;
+	unsigned char	ch, out;
+
+	state = 0;
+	if (!stralloc_copys(dest, "")) return -1;
+	while ((ch = *src++) != '\0') {
+		if (ISSPACE(ch))	/* Skip whitespace anywhere. */
+			continue;
+		
+		if (ch >= '0' && ch <= '9')
+			ch -= '0';
+		else if (ch >= 'a')
+			ch -= ('a' - 10);
+		else 
+			ch -= ('A' - 10);
+		if (ch > 15) 		/* A non-Hex character. */
+			return (-1);
+
+		switch (state) {
+		case 0:
+			out = ch << 4;
+			state = 1;
+			break;
+		case 1:
+			out |= ch;
+			if (!stralloc_append(dest, &out)) return -1;
+			state = 0;
+			break;
+		default:
+			strerr_die1x(111, "Abort: bad state in hex decode.");
+		}
+	}
+	if (state != 0)
+		return -1;
+	return 0;
+}
diff -ruN qmail-1.03-orig/base64.h qmail-1.03-ldap-20060201-orig/base64.h
--- qmail-1.03-orig/base64.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/base64.h	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,59 @@
+/*
+ * Copyright (c) 1999-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#ifndef __BASE64_H__
+#define __BASE64_H__
+/* base64.h for QLDAP modified to use only djb's qmail stuff */
+
+#include "stralloc.h"
+
+/*        *
+ * BASE64 *
+ *        */
+
+/* base63 encode */
+int b64_ntop(unsigned char const *, size_t, char *, size_t);
+
+/* base64 decode */
+int b64_pton(char const *, unsigned char *, size_t);
+
+/* the same as above but this time with a stralloc as destination */
+int b64_ntops(unsigned char const *, size_t , stralloc *);
+
+/* the same as above but this time with a stralloc as destination */
+int b64_ptons(char const *, stralloc *);
+
+int hex_ntops(unsigned char const *, size_t, stralloc *);
+int hex_ptons(char const *, stralloc *);
+
+#endif
diff -ruN qmail-1.03-orig/bouncesaying.c qmail-1.03-ldap-20060201-orig/bouncesaying.c
--- qmail-1.03-orig/bouncesaying.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/bouncesaying.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,4 @@
+#include <unistd.h>
 #include "fork.h"
 #include "strerr.h"
 #include "error.h"
@@ -7,7 +8,7 @@
 
 #define FATAL "bouncesaying: fatal: "
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -38,4 +39,6 @@
   }
 
   strerr_die1x(100,argv[1]);
+  /* NOTREACHED */
+  return 100;
 }
diff -ruN qmail-1.03-orig/byte_chr.c qmail-1.03-ldap-20060201-orig/byte_chr.c
--- qmail-1.03-orig/byte_chr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_chr.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,12 @@
 #include "byte.h"
 
 unsigned int byte_chr(s,n,c)
-char *s;
+const char *s;
 register unsigned int n;
 int c;
 {
   register char ch;
-  register char *t;
+  register const char *t;
 
   ch = c;
   t = s;
diff -ruN qmail-1.03-orig/byte_copy.c qmail-1.03-ldap-20060201-orig/byte_copy.c
--- qmail-1.03-orig/byte_copy.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_copy.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,14 +1,16 @@
 #include "byte.h"
 
 void byte_copy(to,n,from)
-register char *to;
+void *to;
 register unsigned int n;
-register char *from;
+const void *from;
 {
+  register char *t = (char *)to;
+  register const char *f = (const char *)from;
   for (;;) {
-    if (!n) return; *to++ = *from++; --n;
-    if (!n) return; *to++ = *from++; --n;
-    if (!n) return; *to++ = *from++; --n;
-    if (!n) return; *to++ = *from++; --n;
+    if (!n) return; *t++ = *f++; --n;
+    if (!n) return; *t++ = *f++; --n;
+    if (!n) return; *t++ = *f++; --n;
+    if (!n) return; *t++ = *f++; --n;
   }
 }
diff -ruN qmail-1.03-orig/byte_cr.c qmail-1.03-ldap-20060201-orig/byte_cr.c
--- qmail-1.03-orig/byte_cr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_cr.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,16 +1,19 @@
 #include "byte.h"
 
 void byte_copyr(to,n,from)
-register char *to;
+void *to;
 register unsigned int n;
-register char *from;
+const void *from;
 {
-  to += n;
-  from += n;
+  register char *t = (char *)to;
+  register const char *f = (const char *)from;
+
+  t += n;
+  f += n;
   for (;;) {
-    if (!n) return; *--to = *--from; --n;
-    if (!n) return; *--to = *--from; --n;
-    if (!n) return; *--to = *--from; --n;
-    if (!n) return; *--to = *--from; --n;
+    if (!n) return; *--t = *--f; --n;
+    if (!n) return; *--t = *--f; --n;
+    if (!n) return; *--t = *--f; --n;
+    if (!n) return; *--t = *--f; --n;
   }
 }
diff -ruN qmail-1.03-orig/byte_diff.c qmail-1.03-ldap-20060201-orig/byte_diff.c
--- qmail-1.03-orig/byte_diff.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_diff.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,16 +1,19 @@
 #include "byte.h"
 
 int byte_diff(s,n,t)
-register char *s;
+const void *s;
 register unsigned int n;
-register char *t;
+const void *t;
 {
+  register const char *S = (const char *)s;
+  register const char *T = (const char *)t;
+
   for (;;) {
-    if (!n) return 0; if (*s != *t) break; ++s; ++t; --n;
-    if (!n) return 0; if (*s != *t) break; ++s; ++t; --n;
-    if (!n) return 0; if (*s != *t) break; ++s; ++t; --n;
-    if (!n) return 0; if (*s != *t) break; ++s; ++t; --n;
+    if (!n) return 0; if (*S != *T) break; ++S; ++T; --n;
+    if (!n) return 0; if (*S != *T) break; ++S; ++T; --n;
+    if (!n) return 0; if (*S != *T) break; ++S; ++T; --n;
+    if (!n) return 0; if (*S != *T) break; ++S; ++T; --n;
   }
-  return ((int)(unsigned int)(unsigned char) *s)
-       - ((int)(unsigned int)(unsigned char) *t);
+  return ((int)(unsigned int)(unsigned char) *S)
+       - ((int)(unsigned int)(unsigned char) *T);
 }
diff -ruN qmail-1.03-orig/byte.h qmail-1.03-ldap-20060201-orig/byte.h
--- qmail-1.03-orig/byte.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,13 @@
 #ifndef BYTE_H
 #define BYTE_H
 
-extern unsigned int byte_chr();
-extern unsigned int byte_rchr();
-extern void byte_copy();
-extern void byte_copyr();
-extern int byte_diff();
-extern void byte_zero();
+extern unsigned int byte_chr(const char *, unsigned int, int);
+extern unsigned int byte_rchr(const char *, unsigned int, int);
+extern void byte_copy(void *, unsigned int, const void *);
+extern void byte_copyr(void *, unsigned int, const void *);
+extern int byte_diff(const void *, unsigned int, const void *);
+extern void byte_zero(void *, unsigned int);
+extern unsigned int byte_repl(char *, unsigned int, int, int);
 
 #define byte_equal(s,n,t) (!byte_diff((s),(n),(t)))
 
diff -ruN qmail-1.03-orig/byte_rchr.c qmail-1.03-ldap-20060201-orig/byte_rchr.c
--- qmail-1.03-orig/byte_rchr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_rchr.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,13 +1,13 @@
 #include "byte.h"
 
 unsigned int byte_rchr(s,n,c)
-char *s;
+const char *s;
 register unsigned int n;
 int c;
 {
   register char ch;
-  register char *t;
-  register char *u;
+  register const char *t;
+  register const char *u;
 
   ch = c;
   t = s;
diff -ruN qmail-1.03-orig/byte_repl.c qmail-1.03-ldap-20060201-orig/byte_repl.c
--- qmail-1.03-orig/byte_repl.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/byte_repl.c	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,53 @@
+/*
+ * Copyright (c) 2002-2004 Claudio Jeker,
+ *      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgement:
+ *      This product includes software developed by Internet Business
+ *      Solutions AG and its contributors.
+ * 4. Neither the name of the author nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include "byte.h"
+
+/* char replacement */
+unsigned int byte_repl(char *s, unsigned int len, int f, int r)
+{
+   register char *t;
+   int count = 0;
+   char fc;
+   char rc;
+
+   t = s; fc = f; rc = r;
+   for(;;) {
+      if (!len) return count; if (*t == fc) { *t=rc; count++; } ++t; --len;
+      if (!len) return count; if (*t == fc) { *t=rc; count++; } ++t; --len;
+      if (!len) return count; if (*t == fc) { *t=rc; count++; } ++t; --len;
+      if (!len) return count; if (*t == fc) { *t=rc; count++; } ++t; --len;
+   }
+}
+
+
diff -ruN qmail-1.03-orig/byte_zero.c qmail-1.03-ldap-20060201-orig/byte_zero.c
--- qmail-1.03-orig/byte_zero.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/byte_zero.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,13 +1,14 @@
 #include "byte.h"
 
 void byte_zero(s,n)
-char *s;
+void *s;
 register unsigned int n;
 {
+  char *S = (char *)s;
   for (;;) {
-    if (!n) break; *s++ = 0; --n;
-    if (!n) break; *s++ = 0; --n;
-    if (!n) break; *s++ = 0; --n;
-    if (!n) break; *s++ = 0; --n;
+    if (!n) break; *S++ = 0; --n;
+    if (!n) break; *S++ = 0; --n;
+    if (!n) break; *S++ = 0; --n;
+    if (!n) break; *S++ = 0; --n;
   }
 }
diff -ruN qmail-1.03-orig/case_diffb.c qmail-1.03-ldap-20060201-orig/case_diffb.c
--- qmail-1.03-orig/case_diffb.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/case_diffb.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,9 +1,9 @@
 #include "case.h"
 
 int case_diffb(s,len,t)
-register char *s;
+register const char *s;
 unsigned int len;
-register char *t;
+register const char *t;
 {
   register unsigned char x;
   register unsigned char y;
diff -ruN qmail-1.03-orig/case_diffs.c qmail-1.03-ldap-20060201-orig/case_diffs.c
--- qmail-1.03-orig/case_diffs.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/case_diffs.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,8 +1,8 @@
 #include "case.h"
 
 int case_diffs(s,t)
-register char *s;
-register char *t;
+register const char *s;
+register const char *t;
 {
   register unsigned char x;
   register unsigned char y;
diff -ruN qmail-1.03-orig/case.h qmail-1.03-ldap-20060201-orig/case.h
--- qmail-1.03-orig/case.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/case.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,12 @@
 #ifndef CASE_H
 #define CASE_H
 
-extern void case_lowers();
-extern void case_lowerb();
-extern int case_diffs();
-extern int case_diffb();
-extern int case_starts();
-extern int case_startb();
+extern void case_lowers(char *);
+extern void case_lowerb(char *, unsigned int);
+extern int case_diffs(const char *, const char *);
+extern int case_diffb(const char *, unsigned int, const char *);
+extern int case_starts(const char *, const char *);
+extern int case_startb(const char *, unsigned int, const char *);
 
 #define case_equals(s,t) (!case_diffs((s),(t)))
 
diff -ruN qmail-1.03-orig/case_lowers.c qmail-1.03-ldap-20060201-orig/case_lowers.c
--- qmail-1.03-orig/case_lowers.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/case_lowers.c	2006-02-25 11:00:55.000000000 +0100
@@ -4,7 +4,7 @@
 char *s;
 {
   unsigned char x;
-  while (x = *s) {
+  while ((x = *s)) {
     x -= 'A';
     if (x <= 'Z' - 'A') *s = x + 'a';
     ++s;
